/*
 *
 * PROMOTE.PRG
 * ~~~~~~~~~~~
 *
 * This program demonstrates Artful FreshWINs ability to
 * create a simple event driven interface
 *
 * Robert DiFalco
 *
 */

#include "Fresh.ch"
#include "inkey.ch"

FUNCTION Main( )

   local nSavCrs := setcursor( 0 )

   setblink( FALSE )

   winDefs( )

   wOpen( "BackDrop" )

   /*
   * Lazy way to display each window
   * display text and move to the
   * next window.
   */
   wOpen( "C" )
   BProcC( getEvent() )

   wOpen( "B" )
   BProcB( getEvent() )

   wOpen( "A" )
   BProcA( getEvent() )

   *-- Open and display mouse
   MsOpen( )
   MsShow( )

   *-- Main event loop
   while DispatchEvent( getEvent(.2) ) ; enddo

   *-- Close mouse and remaining windows
   MsClose( )
   wKillAll( )

   *-- restore environment
   setcursor( nSavCrs )
   setblink( TRUE )

RETURN devpos( maxrow(), 0 )


STATIC FUNCTION DispatchEvent( aMsg )

   if aMsg[ E_MSG ] == FWM_KEYBOARD             
      do case
      case isalpha( chr( aMsg[ E_P1 ] ) )       // Key selected window
         w2Front( uppe( chr( aMsg[ E_P1 ] ) ) ) // Bring window to front
         aMsg[ E_WIN ] := wOnTop( )

      case aMsg[ E_P1 ] == K_TAB                // TAB foward through windows
         w2Front( wNext( "BackDrop" ) )
         aMsg[ E_WIN ] := wOnTop( )

      endcase
   endif

   *-- Find window procedure and evaluate
   eval( wProc( aMsg[ E_WIN ] ), aMsg )

   *-- Print time, no interrupt routines required
   if !( wTRow() <= 1 ) .or. wRCol() < maxcol() - 11
      PrintStr( 0, maxcol() - 10, AmPm( time() ), 79 )

   endif

RETURN !( lastkey() == 27 )


STATIC FUNCTION winDefs( )

   wNew  ( "BackDrop",,,,,"W+/N*" )
   wTitle( "BackDrop", "FreshWin Event Processing Demo", "N/BG", WT_BAR )
   wFrame( "BackDrop", B_NONE )

   wNew    ( "C", 4, 2, 13, 54, "W+/B, B/W", WS_CUA )
   wTitle  ( "C", "Window C", "B/W", WT_BAR )
   wFrame  ( "C", B_NONE, "W+/B" )
   wHowOpen( "C", B_EXPLODEDN( ) )
   wShadow ( "C", B_SHADOW( ) )
   wProc   ( "C", { | aMsg | BProcC( aMsg ) } )

   wNew    ( "B", 8, 12, 17, 64 , "W+/R, R/W", WS_CUA )
   wTitle  ( "B", "Window B", "R/W", WT_BAR )
   wFrame  ( "B", B_NONE, "W+/R" )
   wHowOpen( "B", B_EXPLODEDN( ) )
   wShadow ( "B", B_SHADOW( ) )
   wProc   ( "B", { | aMsg | BProcB( aMsg ) } )

   wNew    ( "A", 12, 22, 21, 74, "W+/G, G/W", WS_CUA )
   wTitle  ( "A", "Window A", "G/W", WT_BAR )
   wFrame  ( "A", B_NONE, "W+/G" )
   wHowOpen( "A", B_EXPLODEDN( ) )
   wShadow ( "A", B_SHADOW( ) )
   wProc   ( "A", { | aMsg | BProcA( aMsg ) } )

RETURN NIL

FUNCTION BProcA( aMsg )

   local aCargo

   if ( aCargo := wCargoGet( "A", "V_DATA" ) ) == NIL
      wCargoPut( "A", "V_DATA", aCargo := viewNew( "A", "READ.ME" ) )

   endif

   viewUpDate( aMsg, aCargo )

RETURN NIL

FUNCTION BProcB( aMsg )

   local aCargo 

   if ( aCargo := wCargoGet( "B", "V_DATA" ) ) == NIL
      wCargoPut( "B", "V_DATA", aCargo := viewNew( "B", "PROMOTE.PRG" ) )

   endif

   viewUpDate( aMsg, aCargo )

RETURN NIL

FUNCTION BProcC( aMsg )

   local aCargo 

   if ( aCargo := wCargoGet( "C", "V_DATA" ) ) == NIL
      wCargoPut( "C", "V_DATA", aCargo := viewNew( "C", "VIEWFILE.PRG" ) )

   endif

   viewUpDate( aMsg, aCargo )

RETURN NIL

/***
*  AmPm( <cTime> ) --> cTime
*  Convert a time string to 12-hour format
*
*  NOTE:  Same as AMPM() in Examplep.prg
*/
FUNCTION AmPm( cTime )
   local nHour := val( left( cTime, 2 ) )

RETURN str( round( nHour % 12.1, 0 ), 2 ) + ;
            right( cTime, 6 ) + iif( nHour < 12, " am", " pm" )
